=== debian/changelog ===
elisa-player (22.12.3-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (22.12.3).
  * Update build-deps and deps with the info from cmake.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 01 Mar 2023 11:57:43 +0100

elisa-player (22.12.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Re-export upstream signing key without extra signatures.

 -- Pino Toscano <pino@debian.org>  Sun, 05 Feb 2023 07:51:48 +0100
