## elisa-player 23.08.0

=== debian/changelog ===
elisa-player (23.08.0-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 24 Aug 2023 12:49:49 +0100

elisa-player (23.07.90-0ubuntu1) mantic; urgency=medium

  * New upstream (beta) release (23.07.80)
  * New upstream (RC) release (23.07.90)

 -- Rik Mills <rikmills@kde.org>  Tue, 15 Aug 2023 02:29:54 +0100

elisa-player (23.04.3-0ubuntu2) mantic; urgency=medium

  * Add vlc-plugin-base as runtime depend.

 -- Rik Mills <rikmills@kde.org>  Thu, 13 Jul 2023 16:02:22 +0100

elisa-player (23.04.3-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jul 2023 14:42:01 +0100

elisa-player (23.04.2-1ubuntu1) mantic; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.
    - Update upstream signing key.

 -- Rik Mills <rikmills@kde.org>  Mon, 19 Jun 2023 13:28:27 +0100

elisa-player (23.04.2-1) unstable; urgency=medium

  [ Aurélien COUDERC ]
  * New upstream release (23.04.2).
  * Drop patch applied upstream.

 -- Aurélien COUDERC <coucouf@debian.org>  Mon, 19 Jun 2023 00:00:48 +0200

elisa-player (23.04.2-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.1)
  * Delete upstream_7848ea00_set-libvlc-playback-cache-size-to-10-
    seconds.patch
  * New upstream release (23.04.2)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Sat, 10 Jun 2023 11:53:39 +0100

elisa-player (22.12.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 02 Mar 2023 00:34:01 +0000

elisa-player (22.12.2-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.2)

 -- Simon Quigley <tsimonq2@kubuntu.org>  Sat, 11 Feb 2023 14:10:17 -0600

elisa-player (22.12.1-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 05 Jan 2023 11:11:17 +0000

elisa-player (22.12.0-2ubuntu1) lunar; urgency=medium

  * Merge from Debian unstable. Remaining changes:
    - Kubuntu Vcs and maintainer fields.

 -- Rik Mills <rikmills@kde.org>  Mon, 19 Dec 2022 07:49:53 +0000

elisa-player (22.12.0-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 09 Dec 2022 19:04:52 +0000

elisa-player (22.11.90-0ubuntu1) lunar; urgency=medium

  * New upstream (RC) release (22.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Nov 2022 16:01:18 +0000

elisa-player (22.11.80-0ubuntu1) lunar; urgency=medium

  * New upstream (beta) release (22.11.80)

 -- Rik Mills <rikmills@kde.org>  Mon, 14 Nov 2022 10:47:32 +0000

elisa-player (22.08.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 07 Nov 2022 11:04:57 +0000
